      DOUBLE PRECISION XN,YN,XK,EPS,THRESH,H,HMIN,Y,RAB,Q,YT
      PARAMETER (K=18,K2=25)
      DIMENSION RAB(2*K*K+5*K+5*K+K2*K2+5*K2+4*K2+18+1)
      EXTERNAL F,FTREAT
      COMMON/STAT76/NACCEP,NREJEC
      COMMON/BLOCK/N,Q
      M=1
      Q=4.0D0
      XN=0.
      YN=EXP(Q)
      XK=7.D0
      YT =EXP(Q*(XK+1.D0))
      K0=K
      INIAPR=1
      IMAX=28
      IU=2
      EPS=0.5D-13
      THRESH=1.D0
      MEXACT=1
      MESTER=1
      H=1.D0
      HMIN=1.D-3
      K20=K2
      IMAX2=3
      NATTEM=3
      N=0  
      CALL DE74D(F,FTREAT,M,XN,YN,XK,K0,INIAPR,IMAX,IU,EPS,THRESH,
     1           MEXACT,M,MESTER,H,HMIN,K20,IMAX2,NATTEM,Y,RAB,IERR)  
      PRINT 50,IERR
      PRINT 49,N
      PRINT 52,NACCEP,NREJEC
      PRINT 51,Y,YT,(YT-Y)/Y
      STOP
   49 FORMAT(1X,'N=',I12)
   50 FORMAT(1X,'IERR=',I2)
   51 FORMAT(1X,'Y =',D25.16/1X,'YT=',D25.16/1X,'(YT-Y)/Y=',D25.16)
   52 FORMAT(1X, 'NACCEP=',I4,5X,'NREJEC=',I4)
      END
C
      SUBROUTINE F(X,Y,Z,M)
      DOUBLE PRECISION X,Y,Z,Q
      COMMON/BLOCK/N,Q
      Z=Q*Y
      N=N+1
      RETURN
      END

      SUBROUTINE FTREAT(S,XI,XE,Y,AY,ADY,M,KP1,KP2)
      INTEGER S,M,KP1,KP2
      DOUBLE PRECISION XI,XE,Y,AY,ADY,YT,MIDPNT,ALPN,SOL,SOLT,BK(2),Q
      DIMENSION AY(M,KP2),ADY(M,KP1)
C
      PRINT 110,S,XI,XE
      Q=4.D0
      YT =EXP(Q*(XE+1.D0))
      PRINT 30,Y,YT,(YT-Y)/Y
C
      MIDPNT=0.5D0*(XI+XE)
C
C   Transformation of point MIDPNT into a point ALPN of segment [-1, 1]
C
      ALPN=2.D0*(MIDPNT-XI)/(XE-XI)-1.D0      
C  
C   Calculation of partial sum SOL of KP1 order with Chebyshev coefficients AY
C        at point ALPN  (BK - working array  of dimension M*2)
C
      CALL DE70DC(M,KP1,ALPN,AY,SOL,BK)
      SOLT=EXP(Q*(MIDPNT+1.D0))
      PRINT 29,MIDPNT
      PRINT 31,SOL,SOLT,(SOLT-SOL)/SOL
C
      DO 20 L=1,M
      PRINT 150,L
      PRINT 85,(J-1,AY(L,J),ADY(L,J),J=1,KP1), KP1,AY(L,KP2)
   20 CONTINUE
      PRINT 48
      RETURN
C
   29 FORMAT(/1X,'MIDPNT=',D25.16)
   30 FORMAT(1X,'Solution Y and YT at the end  of the segment [XI,XE],',
     1       'i.e. Y(XE), YT(XE):' ,
     2        /1X,'Y =',D25.16/1X,'YT=',D25.16/1X,'(YT-Y)/Y=',D25.16)
   31 FORMAT(/1X,'Solution SOL and SOLT at the midpoint 0.5*(XI+XE)  of',
     1        ' segment [XI, XE]: ',
     2        /1X,'SOL  =',D25.16/1X,'SOLT =',D25.16,
     3        /1X,'(SOLT-SOL)/SOL=',D25.16)
   48 FORMAT(/1X,64(1H*)/) 
   85 FORMAT(5X,I2,5X,2D25.16)
  110 FORMAT(/1X,'COEFFICIENTS AY AND ADY ON ',I3,'  SEGMENT:  '/
     1        1X,'XI=',D25.16,5X,'XE=',D25.16/)
  150 FORMAT(/'   Number of',7X,'Chebyshev coefficients'
     *       ' for ',I1,' component'/  
     1        14X,51(1H-)/
     2       ' coefficient',11X,'for Y',21X,'for Y'''/         
     3        1X,64(1H-)/)
      END
